import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCardBindLog, ThinkCardBindLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询IC卡绑定微信日志表
 */
export async function pageThinkCardBindLog(params: ThinkCardBindLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCardBindLog>>>(
    THINK_API_URL + '/think/think-card-bind-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询IC卡绑定微信日志表列表
 */
export async function listThinkCardBindLog(params?: ThinkCardBindLogParam) {
  const res = await request.get<ApiResult<ThinkCardBindLog[]>>(
    THINK_API_URL + '/think/think-card-bind-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加IC卡绑定微信日志表
 */
export async function addThinkCardBindLog(data: ThinkCardBindLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-bind-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改IC卡绑定微信日志表
 */
export async function updateThinkCardBindLog(data: ThinkCardBindLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-bind-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除IC卡绑定微信日志表
 */
export async function removeThinkCardBindLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-bind-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除IC卡绑定微信日志表
 */
export async function removeBatchThinkCardBindLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-bind-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询IC卡绑定微信日志表
 */
export async function getThinkCardBindLog(id: number) {
  const res = await request.get<ApiResult<ThinkCardBindLog>>(
    THINK_API_URL + '/think/think-card-bind-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
